import opensim as osim
import numpy as np
import os
import glob
import sys
from scipy.spatial.transform import Rotation

# I'm sorry. I don't comment code as I write. I am a hypocrit. You can ask me questions when you have them. Good luck!

model_filename = r"C:\Users\Jesse\Desktop\Arm Paper 2023\Scripts\Data Generation - clipped to reach\Predicted EMG\model_toScale.osim"
model = osim.Model(model_filename)

bodySet = model.getBodySet()
nBodies = bodySet.getSize()

jointSet = model.getJointSet()
nJoints = jointSet.getSize()

muscleSet = model.getMuscles()
nMuscles = muscleSet.getSize()

model.finalizeConnections()
state = model.initSystem()

print("Model loaded with:")
print(nBodies," bodies, and ", nMuscles," muscles, and ", nJoints, " joints.")

print("Body Properties:")
print("==============================")
for i in range(nBodies):
    print("Body",i,"is: ")
    body = bodySet.get(i)
    print("Name: ",body.getName())
    print("Mass: ", body.getMass())
    print("Center of Mass: ",body.getMassCenter ())
    I = body.getInertia()
    Im = I.getMoments();
    Ip = I.getProducts()
    print("Inertia: ", Im,Ip)
    
print("Joint Properties:")
print("==============================")   
meow_woof = dict()
for i in range(nJoints):
    print("Joint",i,"is: ")
    joint = jointSet.get(i)
    print("Name: ", joint.getName())
    print("Joining", joint.getParentFrame().getName(), "to", joint.getChildFrame().getName())
    jof = joint.get_frames(0)
    jofp = jof.get_translation()
    print("This joint is offset from its parent frame by:",jofp[0],jofp[1],jofp[2])
    meow_woof[joint.getChildFrame().getName()] = [jofp[0],jofp[1],jofp[2]]
    jofo = jof.get_orientation()
    print("This joint is rotated from its parent frame by:",jofo[0],jofo[1],jofo[2])
    
    jof = joint.get_frames(1)
    jofp = jof.get_translation()
    print("This joint is offset from its child frame by:",jofp[0],jofp[1],jofp[2])
    
    jofo = jof.get_orientation()
    print("This joint is rotated from its child frame by:",jofo[0],jofo[1],jofo[2])
    
    ncoords = joint.numCoordinates()
    print("This joint has",ncoords,"coordiantes")
    for j in range(ncoords):
        jc = joint.get_coordinates(j)
        print("Coordinate",j+1,"is:",jc.getName())
        print("It has a default value of",jc.get_default_value(),"and a range of",jc.get_range(0),
        'to',jc.get_range(1))
print("+++++++++++++++++++++++++++++++")
print(meow_woof)   
print("+++++++++++++++++++++++++++++++")
    
print("Muscle Properties:")
print("==============================")            
for i in range(nMuscles):
    print("Muscle",i," is: ")
    m = muscleSet.get(i)
    print("Name: ", m.getName())
    p = m.getGeometryPath();
    ps = p.getPathPointSet()
    npoints = ps.getSize();
    print("This muscle has",npoints,"geometry points.")
    for j in range(npoints):
        psp = ps.get(j)
        pl = psp.getLocation(state)
        print("Point",j,", named:",psp.getName(),", is attatched to the",psp.getBody().getName())
        print("The relative attatchement point is", pl[0], pl[1], pl[2])



print("Model loaded with:")
print(nBodies," bodies, and ", nMuscles," muscles, and ", nJoints, " joints.")

# XML Stuff

body_names = [];
body_xml = [];
for i in range(nBodies):
    body = bodySet.get(i)
    body_names.append(body.getName())
    
    
print("Joint Properties:")
print("==============================")    
for i in range(nJoints):
    #print("Joint",i,"is: ")
    #joint = jointSet.get(i)
    #print("Name: ", joint.getName())
    #print("Joining", joint.getParentFrame().getName(), "to", joint.getChildFrame().getName())
    #jof = joint.get_frames(0)
    #jofp = jof.get_translation()
    #jof = joint.get_frames(1)
    #jofp2 = jof.get_translation()
    #print("This joint is offset from its parent frame by:",jofp[0],jofp[1],jofp[2])
    #jofo = jof.get_orientation()
    #print("This joint is rotated from its parent frame by:",f"{jofo[0]:.6f} {jofo[1]:.6f} {jofo[2]:.6f}")
    #
    #jof = joint.get_frames(1)
    #jofp2 = jof.get_translation()
    #print("This joint is offset from its child frame by:",jofp[0],jofp[1],jofp[2])
    #jofo = jof.get_orientation()
    #print("This joint is rotated from its child frame by:",f"{jofo[0]:.6f} {jofo[1]:.6f} {jofo[2]:.6f}")
    #
    ncoords = joint.numCoordinates()
    print("This joint has",ncoords,"coordiantes")
    for j in range(ncoords):
        jc = joint.get_coordinates(j)
        print("Coordinate",j+1,"is:",jc.getName())
        print("It has a default value of",jc.get_default_value(),"and a range of",jc.get_range(0),
        'to',jc.get_range(1))
    #    
    print("Joint",i,"is: ")
    joint = jointSet.get(i)
    print("Name: ", joint.getName())
    print("Joining", joint.getParentFrame().getName(), "to", joint.getChildFrame().getName())
    jof = joint.get_frames(0)
    jofp = jof.get_translation()
    jofo = jof.get_orientation()
    jof = joint.get_frames(1)
    jofp2 = jof.get_translation()
    jofo2 = jof.get_orientation()
    print("This joint's offset:",jofp[0]-jofp2[0],jofp[1]-jofp2[1],jofp[2]-jofp2[2])
    parent_r = Rotation.from_euler("XYZ", [jofo2[0],jofo2[1],jofo2[2]])
    child_r = Rotation.from_euler("XYZ", [jofo[0],jofo[1],jofo[2]])
    parent_r = child_r.inv() * parent_r
    print("This joint's rotation:",parent_r.as_rotvec())
    
    #jof = joint.get_frames(1)
    #jofp2 = jof.get_translation()
    #print("This joint is offset from its child frame by:",jofp[0],jofp[1],jofp[2])
    #jofo = jof.get_orientation()
    #print("This joint is rotated from its child frame by:",f"{jofo[0]:.6f} {jofo[1]:.6f} {jofo[2]:.6f}")
 
        
print("================") 
print("Sites:")
for q in range(nBodies):   
    print(body_names[q])
    for i in range(nMuscles):
        m = muscleSet.get(i)
        p = m.getGeometryPath();
        ps = p.getPathPointSet()
        npoints = ps.getSize();
        for j in range(npoints):
            psp = ps.get(j)
            pl = psp.getLocation(state)
            v = [pl[0], pl[1], pl[2]]    
            voff = meow_woof[(str(body_names[q])+"_offset")]
            for p in range(3):
                v[p] -= voff[p]
            if (psp.getBody().getName() in body_names[q]):
                print("<site name=\"",psp.getName(),"\" pos=\"",f"{v[0]:.6f} {v[1]:.6f} {v[2]:.6f}","\" rgba=\".1 .2 .6 .5\" size=\"0.0002\"/>",sep='')

print("================") 
print("Tendons:")
for i in range(nMuscles):
    m = muscleSet.get(i)
    p = m.getGeometryPath();
    ps = p.getPathPointSet()
    npoints = ps.getSize();
    print("<spatial width=\".0001\" rgba=\".9 0 0 .45\" name=\"",m.getName(),"\">",sep='')
    for j in range(npoints):
        psp = ps.get(j)
        pl = psp.getLocation(state)
        print("<site site=\"",psp.getName(),"\"/>",sep='')
    print("</spatial>")    
    
print("================") 
print("Muscle Actuators:")
print("<actuator>")
for i in range(nMuscles): 
    m = muscleSet.get(i)
    p = m.getGeometryPath();
    ps = p.getPathPointSet()
    npoints = ps.getSize();
    print("<muscle name=\"",m.getName()+"_act\" tendon=\"",m.getName(),"\"/>",sep='')
print("</actuator>")                      